#include "stdafx.h"
#include "mainfunctions.h"
#include "apl_api.h"
#include "TechProcessDlg.h"


//************************************************************************
__declspec(dllexport) bool GetFunctionsList(CArray<CaplItemInfo*, CaplItemInfo*> *strArray)
{
	for(int i= 0; i<functionArraySize; i++)
	{
		strArray->Add(&functionArray[i]);
	}
	return true;
}

__declspec (dllexport) bool add_CreateTP(CaplAPI* api, 
								 aplExtent& inExtent, bool bUpdateUI)
{
	if(!api || ! api->m_data.IsConnected()) return false;
	
	if(!bUpdateUI)
	{
		api->m_prd_mgr.LoadPrdInfo(inExtent);//    
		for(int i= 0; i<inExtent.GetSize(); i++)
		{
			if(!inExtent[i]) continue;if(!inExtent[i]->GetId() || !inExtent[i]->GetType()) continue;

			if(inExtent[i]->GetAccessmode()>aplRO)
			{
				AfxMessageBox(" !");
				return false;
			}
			if(api->m_data.IsKindOf(inExtent[i], api->m_prd_mgr.e_pdf))
			{
				//   
				SetResources();

				CTechProcessDlg dlg;
				dlg.m_api= api;
				dlg.m_pdf=inExtent[i];
				dlg.m_bModeCreate=true;
				dlg.DoModal();
		
				//    
				ResetResources();

			}
		}
	}
	else 
	{
		if(!inExtent.GetSize()) return false;
		if(api->m_data.IsKindOf(inExtent[0], api->m_prd_mgr.e_prd)) return false;
	}
	return true;
}

__declspec (dllexport) bool add_EditTP(CaplAPI* api, 
								 aplExtent& inExtent, bool bUpdateUI)
{
	if(!api || ! api->m_data.IsConnected()) return false;
	
	if(!bUpdateUI)
	{
		if(inExtent.GetSize())
		{
			if(inExtent[0] && inExtent[0]->GetId() && inExtent[0]->GetType())
			{
				if(inExtent[0]->GetAccessmode()>aplRO)
				{
					AfxMessageBox(" !");
					return false;
				}
				if(api->m_data.IsKindOf(inExtent[0], api->m_bp_mgr.e_bp))
				{
					api->m_bp_mgr.LoadBPInfo(inExtent);//   -
					//   
					SetResources();
	
					CTechProcessDlg dlg;
					dlg.m_api= api;
					dlg.m_bp=inExtent[0];
					if(inExtent[0]->GetAccessmode()>aplRW) dlg.m_ReadOnly=true;
					if(inExtent.GetSize()>1)
					{
						if(api->m_data.IsKindOf(inExtent[1], api->m_bp_mgr.e_bp_ref))
						{
							dlg.m_bp_ref=inExtent[1];
						}
					}
					dlg.DoModal();
		
					//    
					ResetResources();
				}
			}
		}
	}
	else 
	{
		if(!inExtent.GetSize()) return false;
		if(!api->m_data.IsKindOf(inExtent[0], api->m_bp_mgr.e_bp)) return false;
		CString buf;
		CaplInstance *type=0;
		api->m_data.GetAttr(inExtent[0],api->m_bp_mgr.a_bp_type,type);
		if(type) 
		{
			api->m_data.GetAttr(type,api->m_bp_mgr.a_bp_type_name,buf);
			if(buf==" ") return true;
		}
		return false;
	}
	return true;
}

//************************************************************************
void SetResources()
{
	if(afxCurrentResourceHandle!=0) 
		_hProcessInstance = AfxGetResourceHandle();
	AfxSetResourceHandle(_hDllInstance);	
}

void ResetResources()
{
	if(_hProcessInstance!=0)
	{
		AfxSetResourceHandle(_hProcessInstance);	
		_hProcessInstance= 0;
	}
}


//************************************************************************
