#if !defined(AFX_TECHPROCESSDLG_H__1D7ABE9B_61DC_45BA_93D1_2EBBB50D6CBB__INCLUDED_)
#define AFX_TECHPROCESSDLG_H__1D7ABE9B_61DC_45BA_93D1_2EBBB50D6CBB__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// TechProcessDlg.h : header file
//
#include "resource.h"
#include "apl_api.h"
#include <apl_gui.h>
#include "InstPropertyCtrl.h"
/////////////////////////////////////////////////////////////////////////////
// CTechProcessDlg dialog

class OperationStruct
{
public:
	long key;
	CaplInstance *bp;
	CString id;
	CString name;
	CaplInstance *oborud;
	double t_op;
	CString mk_ok;
	CString tech_passport;
	int per_amount;
	CaplInstance *instruk;
	CaplInstance *upr_prog;
	CaplInstance *instruk_rel;
	CaplInstance *upr_prog_rel;
	CString razryad;
	CaplInstance *ceh;
	CaplInstance *uchastok;
	CString hardness;
	double to;
	double tv;
	double tpz;
	double tsht;
	CaplInstance *soj;
	CString rm;

	OperationStruct();
};

class PerehodStruct
{
public:
	long key;
	long oper;
	CaplInstance *perehod;
	CString descr;
	double t_per;
	int osn_amount;
	int instr_amount;
	CaplInstance *ac_doc;
	CaplInstance *ac_doc_rel;

	double diametr;
	double dlina;
	double glubina;
	double prohodu;
	double podacha;
	double shpindel;
	double skorost;
	CString obiem;
	CString pi;
	double totv;

	PerehodStruct();
};

class OsnStruct
{
public:
	long perehod;
	CaplInstance *resource;
	CaplInstance *object;
	CaplInstance *res_type;
	double amount;
	CaplInstance *ed_izm;
	CString poz_instr;
	
	OsnStruct();
};

class CTechProcessDlg : public CaplResizableDialog
{
// Construction
public:
	CTechProcessDlg(CWnd* pParent = NULL);   // standard constructor
	bool m_b_select_from_classifier;
	CaplAPI *m_api;
	CaplInstance *m_bp;
	CaplInstance *m_bp_lock;
	CaplInstance *m_pdf;
	CaplInstance *m_prd;
	CaplInstance *m_bp_ref;

	OperationStruct *m_edit_oper;
	int m_last_oper;
	int m_last_oper_col;
	CString m_last_oper_id;

	PerehodStruct *m_edit_perehod;
	int m_last_perehod;
	int m_last_perehod_col;

	OsnStruct *m_edit_osn;
	int m_last_osn;
	int m_last_osn_col;

	bool m_ReadOnly;
	bool m_bModeCreate;
	CArray<OperationStruct,OperationStruct> m_operations;
	CArray<PerehodStruct,PerehodStruct> m_perehods;
	CArray<OsnStruct,OsnStruct> m_osnastka;
	long m_oper_next_key;
	long m_perehod_next_key;

	CComboBox m_combo;
	CComboBox m_combo_char;
	CComboBox m_combo_razryad;
	CComboBox m_combo_res;
	CComboBox m_combo_unit;
	CEdit m_edit;
	CEdit m_edit_id;
	CEdit m_edit_res;
	CEdit m_edit_char;

	//
	CaplInstance *m_mk_ok_char;///
	CaplInstance *m_tp_char;//
	CaplInstance *m_tper_char;//t 
	CaplInstance *m_razryad_char;//t 
	CaplInstance *m_ceh_char;//
	CaplInstance *m_uch_char;//
	CaplInstance *m_poz_instr_char;// 

	CaplInstance *m_hardness_char;	// 
	CaplInstance *m_to_char;		//   
	CaplInstance *m_tv_char;		//   
	CaplInstance *m_tpz_char;		//  .-.   
	CaplInstance *m_tsht_char;		//     
	CaplInstance *m_soj_char;		// .   -. 
	CaplInstance *m_rm_char;		//  ()  

	CaplInstance *m_diametr_char;	//     () 
	CaplInstance *m_dlina_char;		//     
	CaplInstance *m_glubina_char;	//  
	CaplInstance *m_prohodu_char;	//  
	CaplInstance *m_podacha_char;	// , /
	CaplInstance *m_shpindel_char;	//     .
	CaplInstance *m_skorost_char;	//  , /
	CaplInstance *m_obiem_char;		//   ( .; %)    () ( ,    ..)
	CaplInstance *m_pi_char;		//    
	CaplInstance *m_totv_char;		//      

	CaplInstance *m_tp_bp_type;//  
	CaplInstance *m_oper_bp_type;//  
	CaplInstance *m_perehod_bp_type;//  

	//. . 
	CaplInstance *m_sht_unit; 
	
	// 
	CaplInstance *m_oborud_res_type;//

	// 
	CaplInstance *m_instruk_doc_type;//
	CaplInstance *m_upr_doc_type;// 

	//
	CaplInstance *m_ob_classif;//
	CaplInstance *m_osn_classif;// 

	CString m_cur_org_id;
		
	void ShowPerehodEditBoxDouble(CaplInstance *ciCharact, double &dValue, const CRect rect);
	void SetTablesColumns();
	void ReadTPInfo();
	void LoadDocs();
	void SetReadOnlyItems();
	void UpdateOperations(bool undo_check_out_chars=false);
	void UpdateOperationsCtrl();
	void UpdatePerehods(OperationStruct *oper,CaplInstance *oper_bp);
	void UpdatePerehodsCtrl();
	void UpdateOsnastka(PerehodStruct *perehod,CaplInstance *perehod_bp,bool undo_check_out_chars=false);
	void UpdateOsnastkaCtrl();
	bool EndEdit();
	bool EndEditOper();
	bool EndEditPerehod();
	bool EndEditOsn();
	void GetOperNames();
	bool SaveChanges(bool check_in_chars=false);
	void RecalcTOper(long oper);
	void ChangeOperOrder();
// Dialog Data
	//{{AFX_DATA(CTechProcessDlg)
	enum { IDD = IDD_TECHPROCESSDLG_DIALOG };
	CButton	m_use_classifier_ctrl;
	CButton	m_renumber_btn;
	CComboBox	m_material_ctrl;
	CEdit	m_id_ctrl;
	CListCtrl	m_osnastka_ctrl;
	CaplButton	m_delete_osn_btn;
	CaplButton	m_add_osn_btn;
	CListCtrl	m_perehod_ctrl;
	CaplButton	m_el_per_top_btn;
	CaplButton	m_el_per_bottom_btn;
	CaplButton	m_delete_perehod_btn;
	CaplButton	m_add_perehod_btn;
	CListCtrl	m_operation_ctrl;
	CaplButton	m_undo_check_out_btn;
	CEdit	m_prd_name_ctrl;
	CEdit	m_prd_id_ctrl;
	CEdit	m_pdf_id_ctrl;
	CaplButton	m_el_top_btn;
	CaplButton	m_el_bottom_btn;
	CaplButton	m_delete_oper_btn;
	CaplButton	m_check_out_btn;
	CaplButton	m_check_in_btn;
	CaplButton	m_add_oper_btn;
	CaplButton	m_ok_btn;
	CaplButton	m_cancel_btn;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTechProcessDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CTechProcessDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnCheckOut();
	afx_msg void OnUndoCheckOut();
	afx_msg void OnElTop();
	afx_msg void OnElBottom();
	virtual void OnOK();
	virtual void OnCancel();
	afx_msg void OnDeleteOper();
	afx_msg void OnDblclkParams(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnClickParams(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnItemchangedOperations(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDblclkPerehods(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnClickPerehods(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeletePerehod();
	afx_msg void OnElPerTop();
	afx_msg void OnElPerBottom();
	afx_msg void OnItemchangedPerehods(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeleteOsn();
	afx_msg void OnDblclkOsnastka(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnClickOsnastka(NMHDR* pNMHDR, LRESULT* pResult); 
	afx_msg void OnRenumber();
	afx_msg void OnUseClassifier();
	afx_msg void OnDestroy();
	afx_msg void OnAddOsn();
	afx_msg void OnCheckIn();
	afx_msg void OnAddPerehod();
	afx_msg void OnAddOper();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	bool AddOsn();
	bool CheckIn();
	bool AddPerehod();
	bool AddOper();
public:
	afx_msg void OnHdnBegintrackOperations(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnLvnColumnclickOperations(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMSetfocusOperations(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMSetfocusPerehods(NMHDR *pNMHDR, LRESULT *pResult);
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TECHPROCESSDLG_H__1D7ABE9B_61DC_45BA_93D1_2EBBB50D6CBB__INCLUDED_)
